#!/usr/bin/env python
from gimpfu import *

def ColouredEmboss(inImage, inDrawable, option, doFlatten):
    
    pdb.gimp_image_undo_group_start(inImage)
    name = inDrawable.name
    if '.' in name:
        split = name.split(".", 1)
        name = split[0]
    Embossed = inDrawable.copy()
    inImage.add_layer (Embossed, 1)
    Embossed.mode = NORMAL_MODE
    Embossed.name = "Embossed: Image Layer for Emboss Effect"
    Embossed.opacity = 100.0 
    AZIMUTH=45.0; ELEVATION=30.0; DEPTH=20; EMBOSS=1
    pdb.plug_in_emboss (inImage, Embossed, AZIMUTH, ELEVATION, DEPTH, EMBOSS)
    Colouring = inDrawable.copy()
    inImage.add_layer (Colouring, 0)
    Colouring.mode = HARDLIGHT_MODE
    Colouring.name = "Colouring: Image Layer for more Colouring"
    Colouring.opacity = 65.0
    pdb.gimp_brightness_contrast (Colouring, 0, +25)
    if option == True :
        pdb.gimp_hue_saturation (inDrawable, 0, 0, 0, +50)
        pdb.gimp_hue_saturation (Colouring, 0, 0, 0, +50)
    inDrawable.mode = COLOR_MODE
    inDrawable.opacity = 100.0
    # closing
    if doFlatten == True:
        Outcome = pdb.gimp_image_flatten (inImage)
        Outcome.name = name+" Outcome of Coloured Emboss"
    else:
        Outcome = pdb.gimp_layer_new_from_visible (inImage, inImage, name+" Outcome of Coloured Emboss")
        inImage.add_layer (Outcome, -1)
        
    pdb.gimp_curves_spline (Outcome, HISTOGRAM_VALUE, 10,
                               ( 0,   0,  31,  0,  127, 111, 223, 255, 
                               255, 255)
                               )
    
    pdb.gimp_image_undo_group_end (inImage)
    pdb.gimp_displays_flush()
    
    return(Outcome)
     
register(
    "ColouredEmboss",    "ColouredEmboss",    "ColouredEmboss",
    "Diego",             "Diego Nassetti ",   "2017",
    "ColouredEmboss",
    "RGB*",
    [
      (PF_IMAGE, "image", "Input image", None),
      (PF_DRAWABLE, "idrawable", "Input drawable", None),
      (PF_TOGGLE, "saturate", "Saturate Outcome?", False),
      (PF_TOGGLE, "flatten", "Flatten Outcome?", True),
    ],
    [
      (PF_DRAWABLE, "odrawable", "Output drawable", None),  
    ],
    ColouredEmboss,
    menu="<Image>/Diego/Ancillary",
    )

main()
